#Использовать "../../core"

Процедура ОписаниеКоманды(Команда) Экспорт
	
	Команда.Опция("project", "", "Путь к каталогу проекта Git")
	.ТСтрока()
	.Обязательный(Истина);
	
	Команда.Опция("source", "", "Каталоги исходных кодов")
	.ТСтрока()
	.Обязательный(Истина);
	
	Команда.Опция("key", "", "Ключ проекта SonarQube")
	.ТСтрока()
	.ВОкружении("GIT2SONAR_PROJECT_KEY")
	.Обязательный(Истина);
	
	Команда.Опция("url", "", "Адрес сервера SonarQube")
	.ТСтрока()
	.ВОкружении("GIT2SONAR_URL")
	.Обязательный(Истина);
	
	Команда.Опция("token", "", "Токен авторизации SonarQube")
	.ТСтрока()
	.ВОкружении("GIT2SONAR_TOKEN")
	.Обязательный(Истина);
	
	Команда.Опция("date", ТекущаяДата(), "Дата последнего анализа. По умолчанию используется текущая дата")
	.ТДата()
	.ВОкружении("GIT2SONAR_DATE")
	.Обязательный(Истина);

	Команда.Опция("branch", "master", "Git ветка проекта")
	.ТСтрока()
	.ВОкружении("GIT2SONAR_BRANCH");
	
КонецПроцедуры

Процедура ВыполнитьКоманду(Знач Команда) Экспорт
	
	НастройкиЗапуска = Новый Структура;
	НастройкиЗапуска.Вставить("ПутьДоКаталогаПроекта", Команда.ЗначениеОпции("project"));
	НастройкиЗапуска.Вставить("КаталогиИсходныхКодов", Команда.ЗначениеОпции("source"));
	НастройкиЗапуска.Вставить("КлючПроекта", Команда.ЗначениеОпции("key"));
	НастройкиЗапуска.Вставить("АдресСонара", Команда.ЗначениеОпции("url"));
	НастройкиЗапуска.Вставить("ТокенСонара", Команда.ЗначениеОпции("token"));
	НастройкиЗапуска.Вставить("ДатаАнализа", Команда.ЗначениеОпции("date"));
	НастройкиЗапуска.Вставить("ВеткаПроекта", Команда.ЗначениеОпции("branch"));
	
	НастройкиЗапуска.ДатаАнализа = УправлениеАнализом.ДатаДляИстории(НастройкиЗапуска.ДатаАнализа);
	
	Отказ = УправлениеАнализом.ВходящиеНастройкиКомандыУказаныКорректно(НастройкиЗапуска);
	Если Отказ Тогда
		Возврат;
	КонецЕсли;
	
	ПараметрыПриложения.Логирование().Отладка("Проект: " + НастройкиЗапуска.ПутьДоКаталогаПроекта);
	ПараметрыПриложения.Логирование().Отладка("Каталог исходных кодов: " + НастройкиЗапуска.КаталогиИсходныхКодов);
	ПараметрыПриложения.Логирование().Отладка("Ключ проекта: " + НастройкиЗапуска.КлючПроекта);
	ПараметрыПриложения.Логирование().Отладка("Адрес SonarQube: " + НастройкиЗапуска.АдресСонара);
	ПараметрыПриложения.Логирование().Отладка("Токен SonarQube: " + НастройкиЗапуска.ТокенСонара);
	ПараметрыПриложения.Логирование().Отладка("Дата последнего анализа: " + НастройкиЗапуска.ДатаАнализа);
	ПараметрыПриложения.Логирование().Отладка("Ветка проекта: " + НастройкиЗапуска.ВеткаПроекта);
	
	УправлениеАнализом.ЗапуститьМассовыйАнализ(НастройкиЗапуска);
	
КонецПроцедуры